| ghc-6.12.3: The GHC API | Contents | Index

CoreArity

Description
Arit and eta expansion
Synopsis

manifestArity :: CoreExpr -> Arity
exprArity :: CoreExpr -> Arity
exprEtaExpandArity :: DynFlags -> CoreExpr -> Arity
etaExpand :: Arity -> CoreExpr -> CoreExpr

Documentation
manifestArity :: CoreExpr -> Arity
manifestArity sees how many leading value lambdas there are
exprArity :: CoreExpr -> Arity
An approximate, fast, version of `exprEtaExpandArity` The Arity returned is the number of value args the expression can be applied to without doing much work
exprEtaExpandArity :: DynFlags -> CoreExpr -> Arity
etaExpand

:: Arity | Result should have this number of value args
-> CoreExpr | Expression to expand
-> CoreExpr |

`etaExpand n us e ty` returns an expression with the same meaning as `e`, but with arity `n`.

Given:

     e' = etaExpand n us e ty

We should have that:

     ty = exprType e = exprType e'

Produced by Haddock version 2.6.1